'''Falta crear los pitch de cada una de las notas y luego hacer la composicin musical




/'
Registers
---------

The AY-3-8910/8912 contains 16 internal registers as follows:

Register        Function                        Range

 0              Channel A fine pitch            8-bit (0-255)
 1              Channel A course pitch          4-bit (0-15)
 2              Channel B fine pitch            8-bit (0-255)
 3              Channel B course pitch          4-bit (0-15)
 4              Channel C fine pitch            8-bit (0-255)
 5              Channel C course pitch          4-bit (0-15)
 6              Noise pitch                     5-bit (0-31)
 7              Mixer                           8-bit (see below)
 8              Channel A volume                4-bit (0-15, see below)
 9              Channel B volume                4-bit (0-15, see below)
10              Channel C volume                4-bit (0-15, see below)
11              Envelope fine duration          8-bit (0-255)
12              Envelope course duration        8-bit (0-255)
13              Envelope shape                  4-bit (0-15)
14              I/O port A                      8-bit (0-255)
15              I/O port B                      8-bit (0-255)

Notes:

- The AY-3-8912 does not contain register 15.
- The volume registers (8, 9 and 10) contain a 4-bit setting but if bit
  5 is set then that channel uses the envelope defined by register 13 and
  ignores its volume setting.
- The mixer (register 7) is made up of the following bits (low=enabled):

Bit: 7        6        5        4        3        2        1        0
   _         _
   I/O       I/O   Noise    Noise    Noise     Tone     Tone     Tone
     B        A        C        B        A        C        B        A

   The AY-3-8912 ignores bit 7 of this register.

Envelopes
---------

The AY-3-8910/8912 contains the following preset envelopes or waveforms (set
using control register 13). Note that these affect volume only and not the
pitch:

 0      \__________     single decay then off

 4      /|_________     single attack then off

 8      \|\|\|\|\|\     repeated decay

 9      \__________     single decay then off

10      \/\/\/\/\/\     repeated decay-attack
          _________
11      \|              single decay then hold

12      /|/|/|/|/|/     repeated attack
         __________
13      /               single attack then hold

14      /\/\/\/\/\/     repeated attack-decay

15      /|_________     single attack then off

Pitch values
------------

The course and fine pitch registers for each channel are used in the
following fashion (assuming channel A):

Registers 0 and 1 operate together to form channel A's final pitch. The eight
least significant bits are sent to register 0 and the four most significant
bits are sent to register 1. The output frequency is equal to the IC's
incoming clock frequency divided by 16 and then further divided by the number
written to the course and fine pitch registers, so the higher the number
written to these, the lower the pitch. For example, if a frequency of 1KHz
was required and the IC's clock frequency was 1MHz, a total division rate
of 1000 would be needed. The sound generator itself divides by 16 so the
course and fine pitch registers must provide a further division by 62.5 (due
to the fact that 1000/16 is 62.5). A division rate of 62 or 63 will be
accurate enough, since the registers can only store whole numbers. Therefore,
62 or 63 would be written to register 0 and 0 would be written to register
1.

The following frequency table may be useful in musical applications:

Note            Frequency (Hz)          Note            Frequency (Hz)

A               220                     D#              311.1
A#              233.3                   E               329.63
B               246.94                  F               349.23
middle C        261.63                  F#              370
C#              277.2                   G               392
D               293.66                  G#              415.3

For an easy way to generate the required course and fine pitch values, try
the following program:

        10 INPUT "Note value ",n
        20 INPUT "Octave ",o
        30 LET f=INT(n/2^o)
        40 LET c=INT(f/256)
        50 PRINT "Fine = ";f;"  Course = ";c

The pitch values required by this program are as follows:

Note            Value                   Note            Value

C               3421                    F#              2419
C#              3228                    G               2283
D               3047                    G#              2155
D#              2876                    A               2034
E               2715                    A#              1920
F               2562                    B               1892


'/





Dim sonidos (11, 13) As Byte => {_
{50,50,25,25,0,0,4,216,31,0,0,1,1,0}, _
{250,250,0,0,0,0,15,248,31,0,0,10,10,0}, _
{10,10,0,0,0,0,29,216,31,0,0,4,4,0}, _
{10,100,0,0,0,0,15,248,31,0,0,50,50,0}, _
{15,1,0,0,0,0,15,248,31,0,0,50,50,0}, _
{255,1,255,1,255,2,15,248,190,0,5,5,5,0}, _
{50,50,25,25,0,0,4,216,31,0,0,10,10,0}, _ 'Sonido guay de maquinita.
{100,50,50,25,0,0,4,216,31,0,0,10,10,0}, _ 'Sonido guay de maquinita.
{40,200,0,0,0,0,4,216,31,0,0,4,1,4}, _ 'Sonido guay de maquinita.
{240,0,220,0,130,0,14,14,14,0,0,10,10,0}, _ 'Sonido guay de maquinita.
{25,5,9,19,38,5,12,21,17,16,17,8,7,7}, _ 'Boom.
{50,50,25,25,100,100,0,32,32,32,0,20,1,7} _ 'Gameover 
}



Sub ayPlaySound (sonido As Byte)
' Este Sub toca el sonido que se le indica como parmetro
' Los sonidos se definen en la tabla "sonidos", definida
' globalmente.

Dim i As Byte

For i = 0 To 13
Out 65533, i ' Seleccionamos registro AY
Out 49149, sonidos (sonido, i) ' Escribimos un valor en l
Next i
End Sub